#include <RTL.h>
#include "LPC17xx.H"
#include <stdio.h>
#include "main.h"

/***********************************************************************************/
/* A test function to place a message into the Task2 mail queue                    */
/* this allows the test task to inject messages in place of Task1                  */
/***********************************************************************************/

 void injectTestMessage(unsigned int ledLower,unsigned int ledUpper){
	MailMessage* msgPtr; 
				msgPtr = 	_alloc_box(mpoolTask2);																	
				msgPtr->ledLowerNibble = ledLower;
				msgPtr->ledUpperNibble = ledUpper;
				os_mbx_send(MsgBoxTask2, msgPtr, 0xFFFF);
				 printf("LED %d and %d set \n\r",ledLower,ledUpper);}

/************************************************************************************/				
/* The test task runs at a low priority so it does not efect the application tasks  */
/* It receives a character from the ITM and then runs a test function               */				
/************************************************************************************/
				
__task void testTask(void) {
	unsigned int command;
	

	while(1) {	
		command = SER_GetChar();												//wait for an the ITM to receive a character from the debugger
		switch(command){																//Jump to the test function
			case ('1') :
				os_tsk_delete(t_Task1);											//Stop Task1 running
				printf("Task1 Halted \n\r");
				break;
			case ('2') :
				injectTestMessage(0,7);											// Place a message into the Task2 mail queue
			  break;
			case ('3') :
				injectTestMessage(1,6);
				break;
			case ('4') :
				injectTestMessage(2,5);
				break;
			case ('5') :
				injectTestMessage(3,4);
				break;
			case ('6') :
				injectTestMessage(5,9);										//send a message with some invalid parameters
				break;
			case ('7') :
				os_evt_set(0x01,t_Task3);									//Trigger Task3 to clear the LED bank
			  printf("Task3 Triggered to clear LED bank \n\r");
				break;
			case ('8') :
				t_Task1 	= os_tsk_create(Task1, 10);			//Start Task1
				printf("Task1 Started \n\r");
				break;
			case ('9') :
				os_tsk_delete(t_Task2);										//Stop Task2
				printf("Task2 Halted \n\r");
				break;
			case ('0') :
				t_Task2 	= os_tsk_create(Task2, 10);			//Start Task2
				printf("Task2 Started \n\r");
				break;
			default:
					break;
}}}

